// Code generated by gopkg.in/reform.v1. DO NOT EDIT.

package db

import (
	"fmt"
	"strings"

	"gopkg.in/reform.v1"
	"gopkg.in/reform.v1/parse"
)

type billViewType struct {
	s parse.StructInfo
	z []interface{}
}

// Schema returns a schema name in SQL database ("").
func (v *billViewType) Schema() string {
	return v.s.SQLSchema
}

// Name returns a view or table name in SQL database ("bill").
func (v *billViewType) Name() string {
	return v.s.SQLName
}

// Columns returns a new slice of column names for that view or table in SQL database.
func (v *billViewType) Columns() []string {
	return []string{"id", "request_id", "type", "status", "amount", "gateway", "reference_id", "problem", "withdraw_id", "mask", "country", "exchange_rate", "created", "updated"}
}

// NewStruct makes a new struct for that view or table.
func (v *billViewType) NewStruct() reform.Struct {
	return new(Bill)
}

// BillView represents bill view or table in SQL database.
var BillView = &billViewType{
	s: parse.StructInfo{Type: "Bill", SQLSchema: "", SQLName: "bill", Fields: []parse.FieldInfo{{Name: "Id", Type: "int64", Column: "id"}, {Name: "RequestId", Type: "int64", Column: "request_id"}, {Name: "Type", Type: "protobufWallet.BillType", Column: "type"}, {Name: "Status", Type: "protobufWallet.BillStatus", Column: "status"}, {Name: "Amount", Type: "float64", Column: "amount"}, {Name: "Gateway", Type: "protobufWallet.Gateway", Column: "gateway"}, {Name: "ReferenceId", Type: "*string", Column: "reference_id"}, {Name: "Problem", Type: "protobufWallet.BillProblem", Column: "problem"}, {Name: "WithdrawId", Type: "*int64", Column: "withdraw_id"}, {Name: "Mask", Type: "*string", Column: "mask"}, {Name: "Country", Type: "protobufMain.Country", Column: "country"}, {Name: "ExchangeRate", Type: "*float64", Column: "exchange_rate"}, {Name: "Created", Type: "*time.Time", Column: "created"}, {Name: "Updated", Type: "*time.Time", Column: "updated"}}, PKFieldIndex: -1},
	z: new(Bill).Values(),
}

// String returns a string representation of this struct or record.
func (s Bill) String() string {
	res := make([]string, 14)
	res[0] = "Id: " + reform.Inspect(s.Id, true)
	res[1] = "RequestId: " + reform.Inspect(s.RequestId, true)
	res[2] = "Type: " + reform.Inspect(s.Type, true)
	res[3] = "Status: " + reform.Inspect(s.Status, true)
	res[4] = "Amount: " + reform.Inspect(s.Amount, true)
	res[5] = "Gateway: " + reform.Inspect(s.Gateway, true)
	res[6] = "ReferenceId: " + reform.Inspect(s.ReferenceId, true)
	res[7] = "Problem: " + reform.Inspect(s.Problem, true)
	res[8] = "WithdrawId: " + reform.Inspect(s.WithdrawId, true)
	res[9] = "Mask: " + reform.Inspect(s.Mask, true)
	res[10] = "Country: " + reform.Inspect(s.Country, true)
	res[11] = "ExchangeRate: " + reform.Inspect(s.ExchangeRate, true)
	res[12] = "Created: " + reform.Inspect(s.Created, true)
	res[13] = "Updated: " + reform.Inspect(s.Updated, true)
	return strings.Join(res, ", ")
}

// Values returns a slice of struct or record field values.
// Returned interface{} values are never untyped nils.
func (s *Bill) Values() []interface{} {
	return []interface{}{
		s.Id,
		s.RequestId,
		s.Type,
		s.Status,
		s.Amount,
		s.Gateway,
		s.ReferenceId,
		s.Problem,
		s.WithdrawId,
		s.Mask,
		s.Country,
		s.ExchangeRate,
		s.Created,
		s.Updated,
	}
}

// Pointers returns a slice of pointers to struct or record fields.
// Returned interface{} values are never untyped nils.
func (s *Bill) Pointers() []interface{} {
	return []interface{}{
		&s.Id,
		&s.RequestId,
		&s.Type,
		&s.Status,
		&s.Amount,
		&s.Gateway,
		&s.ReferenceId,
		&s.Problem,
		&s.WithdrawId,
		&s.Mask,
		&s.Country,
		&s.ExchangeRate,
		&s.Created,
		&s.Updated,
	}
}

// View returns View object for that struct.
func (s *Bill) View() reform.View {
	return BillView
}

// check interfaces
var (
	_ reform.View   = BillView
	_ reform.Struct = (*Bill)(nil)
	_ fmt.Stringer  = (*Bill)(nil)
)

func init() {
	parse.AssertUpToDate(&BillView.s, new(Bill))
}
